import { __assign } from './../external/tslib/tslib.es6.js';
import React from 'react';
import classnames from 'classnames';
import { parseMetadata } from '@highlight-ui/utils-commons';
import iconColorTokens from '@highlight-ui/tokens/dist/iconColors.json';
import styles from './Icon.module.scss.js';
var familyPrefixMap = {
  regular: 'far',
  light: 'fal',
  solid: 'fas'
};

function IconWithRef(_a, ref) {
  var _b;

  var _c = _a.block,
      block = _c === void 0 ? false : _c,
      className = _a.className,
      color = _a.color,
      metadata = _a.metadata,
      name = _a.name,
      _d = _a.size,
      size = _d === void 0 ? 14 : _d,
      _e = _a.spin,
      spin = _e === void 0 ? false : _e,
      _f = _a.type,
      type = _f === void 0 ? 'regular' : _f;
  var classNames = classnames(familyPrefixMap[type], "fa-" + name, (_b = {}, _b[styles.block] = block, _b[styles.spin] = spin, _b), className);
  return /*#__PURE__*/React.createElement("i", __assign({}, parseMetadata(metadata), {
    className: classNames,
    ref: ref,
    style: {
      fontSize: size,
      color: color && iconColorTokens[color]
    }
  }));
}

IconWithRef.displayName = 'Icon';
var Icon = /*#__PURE__*/React.forwardRef(IconWithRef);
export { Icon as default };
//# sourceMappingURL=Icon.js.map
